#include "StrList.H"

StrList::StrList(bool sort):
	_sort(sort) {
	pthread_mutex_init(&_lock,NULL);
}

StrList::StrList(const StrList &sl):
	_list(sl._list) {
	pthread_mutex_init(&_lock,NULL);
}

StrList::~StrList() {
	pthread_mutex_destroy(&_lock);
}

StrList &StrList::operator=(const StrList &sl) {
	tlock();
	_list=sl._list; 
	tunlock();
	return (*this);
}

StrList &StrList::operator=(const string first) {
	tlock();
	_list.clear();
	tunlock();
	if (first.length())
		add(first);
	return (*this);
}

int StrList::add(const string &str) {
	list<string>::iterator
		inc;
	int
		match;

	tlock();
	if (!_list.size() || !(_sort)) {
		_list.push_back(str);
		tunlock();
		return 0;
	}
	for (inc=_list.begin(); inc != _list.end(); inc++) {
		match=strcasecmp(str.c_str(),(*inc).c_str());
		if (match==0) {
			tunlock();
			return -1;
		}
		else if (match > 0)
			continue;
		else 
			break;
	}
	_list.insert(inc, str);
	tunlock();
	return 0;
}

int StrList::add(const StrList &strlist) {
	unsigned int i;
	for (i=0; i < strlist.size(); i++)
		add(strlist[i]);
	return i;
}

int StrList::remove(const string &str) {
	list<string>::iterator
		inc;

	tlock();
	if (!_list.size()) {
		tunlock();
		return -1;
	}
	for (inc=_list.begin(); inc != _list.end(); inc++) {
		if ((strcasecmp(str.c_str(),(*inc).c_str())) == 0) {
			_list.erase(inc);
			tunlock();
			return 0;
		}
	}
	tunlock();
	return -1;
}

int StrList::remove(unsigned int idx) {
	list<string>::iterator
		inc;
	unsigned int
		count;

	tlock();
	if (idx >= _list.size()) {
		tunlock();
		return -1;
	}
	for (inc=_list.begin(), count=0; inc != _list.end(); inc++, count++) {
		if (idx==count) {
			_list.erase(inc);
			tunlock();
			return 0;
		}
	}
	tunlock();
	return -2;
}

bool StrList::inlist(const string &str) const {
	list<string>::const_iterator
		inc;

	tlock();
	for (inc=_list.begin(); inc != _list.end(); inc++) {
		if (!strcasecmp(str.c_str(),(*inc).c_str())) {
			tunlock();
			return true;
		}
	}
	tunlock();
	return false;
}

string StrList::operator[](unsigned int idx) const {
	list<string>::const_iterator
		inc;
	unsigned int
		i=0;	
	string
		tmp;
	tlock();
	for (inc=_list.begin(); inc != _list.end(); i++, inc++) {
		if (i==idx) {
			tmp=(*inc);
			tunlock();
			return (tmp);
		}
	}
	tunlock();
	return (tmp);
}
